//
//  Chromium_ESAppDelegate.m
//  Chromium ES
//
//  Created by Daniel Eisner on 11/5/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "Chromium_ESAppDelegate.h"
#import "Chromium_ESViewController.h"


#ifdef HAVE_OPENFEINT
#import "OpenFeint.h"
#endif

#import "appirater/Appirater.h"
#import "achievements.h"
#import "Config.h"


@implementation Chromium_ESAppDelegate

@synthesize window;
@synthesize viewController;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
/*	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
		[window setFrame:CGRectMake(0, 0, 240, 320)];
	} else if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
		[window setFrame:CGRectMake(0, 0, 768, 1024)];
	}
*/	
	[self.window addSubview:self.viewController.view];
	
	[Appirater appLaunched:YES];
	
#ifdef HAVE_OPENFEINT	
	// Initialize OpenFeint
	OFDelegatesContainer* delegates = [OFDelegatesContainer containerWithOpenFeintDelegate:self];
	
	NSDictionary* settings = [NSDictionary dictionaryWithObjectsAndKeys:
							  [NSNumber numberWithInt:UIInterfaceOrientationPortrait], OpenFeintSettingDashboardOrientation,
							  @"Chromium", OpenFeintSettingShortDisplayName, 
							  [NSNumber numberWithBool:YES], OpenFeintSettingEnablePushNotifications,
							  [NSNumber numberWithBool:YES], OpenFeintSettingGameCenterEnabled,
							  //[NSNumber numberWithBool:NO], OpenFeintSettingDisableChat,
							  nil
							  ];
	
	[OpenFeint initializeWithProductKey:@"XXXX"
                              andSecret:@"XXXX"
                         andDisplayName:@"Chromium ES"
                            andSettings:settings    // see OpenFeintSettings.h
                           andDelegates:delegates]; // see OFDelegatesContainer.h

#endif
    return YES;
}


#ifdef HAVE_OPENFEINT
- (void)dashboardWillDisappear {}
- (void)dashboardDidDisappear { [viewController startAnimation]; }
- (void)dashboardDidAppear { [viewController stopAnimation]; }
- (void)dashboardWillAppear {}
- (void)userLoggedIn:(NSString*)userId {}
#endif

- (void)applicationWillResignActive:(UIApplication *)application
{
#ifdef HAVE_OPENFEINT
    [OpenFeint applicationWillResignActive];
#endif
	[self.viewController stopAnimation];
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
#ifdef HAVE_OPENFEINT
	[OpenFeint applicationDidBecomeActive];
#endif
    [self.viewController startAnimation];
}

- (void)applicationWillTerminate:(UIApplication *)application
{
#ifdef HAVE_OPENFEINT
	[OpenFeint shutdown];
#endif

	Achievements::getInstance()->saveToFile();
	Config::instance()->saveFile();
	
    [self.viewController stopAnimation];
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Handle any background procedures not related to animation here.
#ifdef HAVE_OPENFEINT
	[OpenFeint applicationDidEnterBackground];
#endif
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Handle any foreground procedures not related to animation here.
#ifdef HAVE_OPENFEINT
	[OpenFeint applicationWillEnterForeground];
#endif
	
	[Appirater appEnteredForeground:YES];
}

- (void)dealloc
{

    [viewController release];
    [window release];
    
    [super dealloc];
}

@end
