/*
 * Copyright (c) 2000 Mark B. Allan. All rights reserved.
 *
 * "Chromium B.S.U." is free software; you can redistribute 
 * it and/or use it and/or modify it under the terms of the 
 * "Clarified Artistic License"
 */
#ifndef EnemyFleet_h
#define EnemyFleet_h

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "compatibility.h"

#ifdef HAVE_APPLE_OPENGL_FRAMEWORK
#include <OpenGL/gl.h>
#else
#ifdef HAVE_IOS
#include <OpenGLES/ES1/gl.h>
#else
#include <GL/gl.h>
#endif
#endif

#include "EnemyAircraft.h"

class Global;

//====================================================================
class EnemyFleet : public RenderPrimative
{
public:
	EnemyFleet();
	~EnemyFleet();

	void	drawGL();
	void	clear();
	
	void	addEnemy(EnemyAircraft *);
	void	killEnemy(EnemyAircraft *);
	
	void	destroyAll();
	void	retarget(EnemyType et, ScreenItem *newTarget);
	
	void			toFirst();
	EnemyAircraft	*getShip();
	
	void	update();
	
	void	loadTextures();
	void	deleteTextures();
	
private:
	
	void	bossExplosion(EnemyAircraft *);

private:
	GLuint			shipTex[NumEnemyTypes];
	GLuint			extraTex[NumEnemyTypes];
	
	EnemyAircraft	*squadRoot;
	EnemyAircraft	*currentShip;

private:
	Global	*game;
};

#endif // EnemyFleet_h
