/*
 *  RenderPrimative.h
 *  chromium
 *
 *  Created by Daniel Eisner on 10/27/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */
#ifndef RenderPrimative_h
#define RenderPrimative_h

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "compatibility.h"

#ifdef HAVE_APPLE_OPENGL_FRAMEWORK
#include <OpenGL/gl.h>
#else
#ifdef HAVE_IOS
#include <OpenGLES/ES1/gl.h>
#else
#include <GL/gl.h>
#endif
#endif

class RenderPrimative
{
protected:
	inline void drawQuad(float szx, float szy)
	{
#ifdef HAVE_GLESv1
		static const GLfloat texCoord[] = {
			1.0, 0.0,
			0.0, 0.0,
			1.0, 1.0,
			0.0, 1.0,};

		GLfloat vertices[] = {
			 szx,  szy, 0.0,
			-szx,  szy, 0.0,
			 szx, -szy, 0.0,
			-szx, -szy, 0.0,};
		
		glDisableClientState( GL_NORMAL_ARRAY );
		glDisableClientState( GL_COLOR_ARRAY );
		glEnableClientState(  GL_VERTEX_ARRAY );
		glEnableClientState( GL_TEXTURE_COORD_ARRAY );

		glVertexPointer(3, GL_FLOAT, 0, vertices);
		glTexCoordPointer(2, GL_FLOAT, 0, texCoord);
		glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
		
#else
		glBegin(GL_TRIANGLE_STRIP);
		glTexCoord2f(1.0, 0.0); glVertex3f( szx,  szy, 0.0);
		glTexCoord2f(0.0, 0.0); glVertex3f(-szx,  szy, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( szx, -szy, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-szx, -szy, 0.0);
		glEnd();
#endif
	}	

};

#endif