/*
 *  achievements.h
 *  Chromium ES
 *
 *  Created by Daniel Eisner on 11/15/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include <cstdio>

#ifndef ACHIEVEMENTS_H_
#define ACHIEVEMENTS_H_

#define ACHIEVEMENT_VERSION 1
#define ASTRLEN 512


#define ACHIEVE_ENEMY_KILLED_GOAL_1		1000
#define      ID_ENEMY_KILLED_GOAL_1    1 

#define ACHIEVE_ENEMY_KILLED_GOAL_2		2500
#define      ID_ENEMY_KILLED_GOAL_2    2

#define ACHIEVE_ENEMY_KILLED_GOAL_3		5000
#define      ID_ENEMY_KILLED_GOAL_3    3

#define ACHIEVE_BULLDOZER_KILLED_GOAL	400
#define      ID_BULLDOZER_KILLED_GOAL	4

#define ACHIEVE_UFO_KILLED_GOAL			1000
#define      ID_UFO_KILLED_GOAL			5

#define ACHIEVE_GNAT_KILLED_GOAL		300
#define      ID_GNAT_KILLED_GOAL		6

#define ACHIEVE_POWERUP_MISSED_GOAL		40
#define      ID_POWERUP_MISSED_GOAL		7

#define ACHIEVE_EXTRA_LIVES_GOAL		25
#define      ID_EXTRA_LIVES_GOAL		8

#define		 ID_REACH_FIRST_BOSS		9
#define		 ID_DEFEAT_FIRST_BOSS		10
#define		 ID_DEFEAT_SECOND_BOSS		11

typedef struct AchievementData {
		// Stats we want to track
	short version;
	char playerName[ASTRLEN];
	int enemiesKilled;
	int ufosKilled;
	int bulldozersKilled;
	int gnatsKilled;
	int powerupsMissed;
	int extraLives;
};



// Singleton Class
class Achievements
{
public:
	static Achievements *getInstance();

	~Achievements();
	
	// Register that the given achievement was completed.
	void setAchievement(int achievement);
	void saveToFile();   // Saves the stored player to disk
	
	// functions to update our stats
	void enemyKilled()     { checkPlayer(); ++data.enemiesKilled;    checkAchievements(); }
	void ufoKilled()       { checkPlayer(); ++data.ufosKilled;       checkAchievements(); }
	void bulldozerKilled() { checkPlayer(); ++data.bulldozersKilled; checkAchievements(); }
	void gnatKilled()      { checkPlayer(); ++data.gnatsKilled;      checkAchievements(); }
	void powerupMissed()   { checkPlayer(); ++data.powerupsMissed;   checkAchievements(); }
	void extraLife()       { checkPlayer(); ++data.extraLives;       checkAchievements(); }
	
protected:
	static Achievements* theAchievements;
	static char * getPlayerName();
	static char * getFileName(const char* playerName = NULL);

	AchievementData data;
	
	// File I/O
	void loadFromFile(); // Loads the current player's settings from disk
	void checkPlayer();

	void checkAchievements();
	
	// Only allow private init
	Achievements();
};



#endif
